'Basic data for UDP Proton-Net interface (c) Iosoft Ltd. 2003
'
' v0.01 LJ  20/1/03 Split off from pb_udp.bas v1.01

	DATA NIC_INIT,  0        	'NIC initialisation:
	DATA RESPORT,   $01         'Reset NIC
	DATA T_WAIT,    2           'Wait 2ms
	DATA CMDR,      $21         'Stop, DMA abort (wait 2ms)
	DATA T_WAIT,    2           'Wait 2ms
	DATA DCR,       $48         'Data config
	DATA RBCR0,     $00         'Clear RBCR
	DATA RBCR1,     $00
	DATA RCR,       $20         'Rx monitor mode
	DATA TCR,       $02         'Tx internal loopback
	DATA TPSR,      TXSTART     'Tx start page
	DATA PSTART,    RXSTART     'Rx start page
	DATA PSTOP,     RXSTOP      'Rx stop page
	DATA BNRY,      RXSTOP - 1  'Rx boundary
	DATA ISR,       $ff         'Clear interrupt flags
	DATA IMR,       $00         'Mask all interrupts
	DATA CMDR,      $61         'Stop, DMA abort, page 1
	DATA T_WAIT,    2           'Wait 2ms
	DATA PAR0,      $02         'MAC addr; local admin (U/L = 1)
	DATA PAR0 + 1,    $00
	DATA PAR0 + 2,    $00
	DATA PAR0 + 3,    $00
	DATA PAR0 + 4,    $00
	DATA PAR0 + 5,    MYID
	DATA MAR0,      $ff         'Mcast addr; accept all
	DATA MAR0 + 1,    $ff
	DATA MAR0 + 2,    $ff
	DATA MAR0 + 3,    $ff
	DATA MAR0 + 4,    $ff
	DATA MAR0 + 5,    $ff
	DATA CURRP,     RXSTART + 1
	DATA CMDR,      $20
	DATA RCR,       $04
	DATA TCR,       $00
	DATA ISR,       $ff
	DATA CMDR,      $22
	DATA T_STOP,    0           'End of this task

	DATA TX_ARPREQ, 0      'Tx broadcast ARP request
	DATA ISR,       $40         'Clear remote DMA int flag
	DATA RSAR0,     0           'Set remote DMA addr
	DATA RSAR1,     TXSTART
	DATA CMDR,      $12         'Start DMA remote write
	DATA DPORT,     $ff         'Broadcast addr
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA DPORT,     $08         'Ether pcol 0806: ARP
	DATA DPORT,     $06
	DATA DPORT,     $00         'ARP hardware type 0001: Ethernet
	DATA DPORT,     $01
	DATA DPORT,     $08         'ARP protocol type 0800: IP
	DATA DPORT,     $00
	DATA DPORT,     MACLEN      'ARP hardware addr len
	DATA DPORT,     IPADDRLEN   'ARP pcol addr len
	DATA DPORT,     $00         'ARP operation 0001: request
	DATA DPORT,     $01
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA T_VOUT4,   V_LOC_IP    'Local IP addr
	DATA DPORT,     $ff         'Target MAC addr: broadcast
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA DPORT,     $ff
	DATA T_VOUT4,   V_REMGATE_IP
	DATA T_STOP,    0           'End of this task

	DATA TX_ARPRSP, 0       'Tx ARP response
	DATA ISR,       $40         'Clear remote DMA int flag
	DATA RSAR0,     0           'Set remote DMA addr
	DATA RSAR1,     TXSTART
	DATA CMDR,      $12         'Start DMA remote write
	DATA T_VOUT6,   V_RESP_MAC  'Respond to Rx MAC addr
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA DPORT,     $08         'ARP protocol
	DATA DPORT,     $06
	DATA DPORT,     $00         'ARP hardware type 0001: Ethernet
	DATA DPORT,     $01
	DATA DPORT,     $08         'ARP protocol type 0800: IP
	DATA DPORT,     $00
	DATA DPORT,     MACLEN      'ARP hardware addr len
	DATA DPORT,     IPADDRLEN   'ARP pcol addr len
	DATA DPORT,     $00         'ARP operation 0002: response
	DATA DPORT,     $02
	DATA T_VOUT6,   V_LOC_MAC   'Sender MAC addr
	DATA T_VOUT4,   V_LOC_IP    'Sender IP addr
	DATA T_VOUT6,   V_RESP_MAC  'Target MAC addr
	DATA T_VOUT4,   28          'Target IP addr
	DATA T_STOP,    0           'End of this task

	DATA TX_ICMPRSP,0       'Tx ICMP response
	DATA RSAR0,     0           'Set remote DMA addr
	DATA RSAR1,     TXSTART
	DATA CMDR,      $12         'Start DMA remote write
	DATA T_VOUT6,   V_RESP_MAC  'Respond to Rx MAC addr
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA DPORT,     $08         'IP protocol
	DATA DPORT,     $00
	DATA DPORT,     $45         'IP v4, header len 20 bytes
	DATA DPORT,     0           'Normal service
	DATA T_VOUT2,   V_IPLEN     'Length of IP datagram
	DATA DPORT,     0           'Identifier
	DATA DPORT,     1
	DATA DPORT,     0           'No fragmentation
	DATA DPORT,     0
	DATA DPORT,     128         'Time to live
	DATA DPORT,     1           'Protocol ICMP
	DATA DPORT,     $0          'Checksum
	DATA DPORT,     $0
	DATA T_VOUT4,   V_LOC_IP    'Source IP addr
	DATA T_VOUT4,   26          'Dest IP addr
	DATA T_STOP,    0           'End of this task

	DATA TX_CLIENTREQ,0      'Tx UDP client request
	DATA RSAR0,     0           'Set remote DMA addr
	DATA RSAR1,     TXSTART
	DATA CMDR,      $12         'Start DMA remote write
	DATA T_VOUT6,   V_REM_MAC   'Send to remote MAC addr
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA DPORT,     $08         'IP protocol
	DATA DPORT,     $00
	DATA DPORT,     $45         'IP v4, header len 20 bytes
	DATA DPORT,     0           'Normal service
	DATA T_VOUT2,   V_IPLEN     'Length of IP datagram
	DATA DPORT,     0           'Identifier
	DATA DPORT,     1
	DATA DPORT,     0           'No fragmentation
	DATA DPORT,     0
	DATA DPORT,     128         'Time to live
	DATA DPORT,     17          'Protocol UDP
	DATA DPORT,     $0          'Dummy checksum
	DATA DPORT,     $0
	DATA T_VOUT4,   V_LOC_IP    'Source IP addr
	DATA T_VOUT4,   V_REM_IP    'Dest IP addr
	DATA DPORT,     4           'Source port 1024
	DATA DPORT,     0
	DATA DPORT,     REMPORT/256 'Destination port 37 (RFC 868 time)
	DATA DPORT,     REMPORT//256
	DATA DPORT,     0           'Length 8 (header + no data)
	DATA DPORT,     8
	DATA DPORT,     0           'Disable checksum
	DATA DPORT,     0
	DATA T_STOP,    0           'End of this task

	DATA TX_MSGRSP, 0      'Tx UDP message response
	DATA RSAR0,     0           'Set remote DMA addr
	DATA RSAR1,     TXSTART
	DATA CMDR,      $12         'Start DMA remote write
	DATA T_VOUT6,   V_RESP_MAC  'Send to response MAC addr
	DATA T_VOUT6,   V_LOC_MAC   'Local MAC addr
	DATA DPORT,     $08         'IP protocol
	DATA DPORT,     $00
	DATA DPORT,     $45         'IP v4, header len 20 bytes
	DATA DPORT,     0           'Normal service
	DATA T_VOUT2,   V_IPLEN     'Length of IP datagram
	DATA DPORT,     0           'Identifier
	DATA DPORT,     1
	DATA DPORT,     0           'No fragmentation
	DATA DPORT,     0
	DATA DPORT,     128         'Time to live
	DATA DPORT,     17          'Protocol UDP
	DATA DPORT,     $0          'Dummy checksum
	DATA DPORT,     $0
	DATA T_VOUT4,   V_LOC_IP    'Source IP addr
	DATA T_VOUT4,   26          'Dest IP addr
	DATA DPORT,     MSGPORT/256 'Source port
	DATA DPORT,     MSGPORT//256
	DATA T_VOUT2,   34          'Destination port (= incoming source port)
	DATA T_VOUT2,   V_UDPLEN    'UDP length (header + data)
	DATA DPORT,     0           'Disable checksum
	DATA DPORT,     0
	DATA DPORT,     "A"         'UDP data: voltage value
	DATA DPORT,     "D"
	DATA DPORT,     "C"
	DATA DPORT,     "="
	DATA T_VOUT4,   V_VOLTAGE
	DATA DPORT,     "V"
	DATA T_STOP,    0           'End of this task
	DATA T_END,     0           'End of all task data
        