'Basic variables for UDP Proton-Net interface (c) Iosoft Ltd. 2003
'
' v0.01 LJ  20/1/03 Split off from pb_udp.bas v1.01

	LCD_DTPIN       = PORTD.0
	LCD_RSPIN       = PORTD.4
	LCD_ENPIN       = PORTA.5
	LCD_INTERFACE   = 4         ' 4-bit Interface
	LCD_LINES       = 2
	LCD_TYPE        = 0

	HSERIAL_BAUD    = 9600      ' Set baud rate to 9600
	HSERIAL_RCSTA   = %10010000 ' Enable serial port and continuous receive
	HSERIAL_TXSTA   = %00100100 ' Enable transmit and asynchronous mode
	HSERIAL_CLEAR   = ON        ' Enable Error clearing on received characters

    ADIN_RES 		= 10
	ADIN_TAD 		= 32_FOSC
 
'Size of receive buffer
	SYMBOL RXBUFFLEN = 74

'User LED
	SYMBOL ULED1    = PORTA.2

'System LED
	SYMBOL SYSLED   = PORTA.4
	SYMBOL LCD_E    = PORTA.5

'NIC interfaces
	SYMBOL NICADDR  = PORTB
	SYMBOL NICDATA  = PORTD
	SYMBOL NIC_IOR  = PORTE.0
	SYMBOL NIC_IOW  = PORTE.1
	SYMBOL NIC_RST  = PORTE.2

'NE2000 registers
	SYMBOL DPORT    = $10
	SYMBOL RESPORT  = $1f

'NIC page 0 registers
	SYMBOL CMDR     = $00
	SYMBOL PSTART   = $01
	SYMBOL PSTOP    = $02
	SYMBOL BNRY     = $03
	SYMBOL TPSR     = $04
	SYMBOL TBCR0    = $05
	SYMBOL TBCR1    = $06
	SYMBOL ISR      = $07
	SYMBOL RSAR0    = $08
	SYMBOL RSAR1    = $09
	SYMBOL RBCR0    = $0a
	SYMBOL RBCR1    = $0b
	SYMBOL RCR      = $0c
	SYMBOL TCR      = $0d
	SYMBOL DCR      = $0e
	SYMBOL IMR      = $0f
'NIC page 1 registers
	SYMBOL PAR0     = $01
	SYMBOL CURRP    = $07
	SYMBOL MAR0     = $08

'Dummy register values: task markers
	SYMBOL T_END        = $ff 'End of all data
	SYMBOL T_STOP       = $fe 'End of data for this mode
	SYMBOL T_WAIT       = $fd 'Wait 2 ms

	SYMBOL NIC_INIT     = $fc 'NIC init
	SYMBOL TX_ARPREQ    = $f9 'Tx ARP request
	SYMBOL TX_ARPRSP    = $f8 'Tx ARP response
	SYMBOL TX_ICMPRSP   = $f7 'Tx ICMP response
	SYMBOL TX_MSGRSP    = $f6 'Tx UDP message response
	SYMBOL TX_CLIENTREQ = $f5 'Tx client (time) request
	SYMBOL TASKBASE     = $f0 'Base value for task codes
	SYMBOL T_VOUT6      = $e3 'Output a 6-byte variable
	SYMBOL T_VOUT4      = $e2 'Output a 4-byte variable
	SYMBOL T_VOUT2      = $e1 'Output a 2-byte variable
	SYMBOL T_VOUT1      = $e0 'Output a 1-byte variable

'Markers for variables
	SYMBOL V_LOC_MAC    = $ef 'Local MAC address
	SYMBOL V_LOC_IP     = $ee 'Local IP address
	SYMBOL V_REM_MAC    = $ed 'Remote MAC address
	SYMBOL V_REM_IP     = $ec 'Remote IP address
	SYMBOL V_REMGATE_IP = $eb 'Remote IP address or gateway IP address
	SYMBOL V_RESP_MAC   = $ea 'Response to incoming MAC address
	SYMBOL V_IPLEN      = $e9 'IP length
	SYMBOL V_UDPLEN     = $e8 'UDP length
	SYMBOL V_VOLTAGE    = $e0 '4-character ADC voltage value
	SYMBOL V_BASE       = $e0 'Base value for var markers

'NIC RAM definitions
	SYMBOL RAMPAGES     = $20
	SYMBOL TXSTART      = $40
	SYMBOL TXPAGES      = 6
	SYMBOL TXBUFFS      = 1
	SYMBOL RXSTART      = TXSTART + (TXPAGES * TXBUFFS)
	SYMBOL RXSTOP       = TXSTART + RAMPAGES - 1

'General Ethernet & IP definitions
	SYMBOL MACLEN       = 6
	SYMBOL IPADDRLEN    = 4
	SYMBOL CRCLEN       = 4
	SYMBOL ETHLEN       = MACLEN + MACLEN + 2
	SYMBOL MINFRAME     = 60
	SYMBOL MAXFRAME     = 1514
	SYMBOL MINFRAMEC    = MINFRAME + CRCLEN
	SYMBOL MAXFRAMEC    = MAXFRAME + CRCLEN
	SYMBOL PCOL_ARP     = $0806
	SYMBOL PCOL_IP      = $0800
		
'------------------------------------------------------------------

	DIM a AS BYTE
	DIM b AS BYTE
	DIM i AS BYTE
	DIM w AS WORD
    DIM task AS BYTE
    DIM csuml AS BYTE: DIM csumh AS BYTE: DIM csumf AS BIT
    DIM nicd AS BYTE: DIM curr_page AS BYTE: DIM next_page AS BYTE
    	
'Rx buffer
    DIM rxlen AS BYTE
	DIM rxbuff[RXBUFFLEN] AS BYTE

	DIM datalen AS BYTE: DIM iplen AS BYTE
	
	DIM idx AS BYTE: DIM matched AS BYTE
	DIM txlen AS BYTE
	DIM rem_mac[MACLEN] AS BYTE
	DIM rem_ip[IPADDRLEN] AS BYTE
	DIM gw_ip[IPADDRLEN] AS BYTE

'NIC Rx status data
	DIM rxstat[4] AS BYTE
	SYMBOL rxblen_ 		= rxstat#2
	SYMBOL rxblen_h 	= rxstat#3
	SYMBOL rxblen 		= rxblen_.WORD

'Timer constants & variables
	SYMBOL SECTICKS = 10
	SYMBOL TIMER1_DIV =  CPU_MHZ / (8 * SECTICKS * 1024)
	DIM tc AS BYTE: DIM lastc AS BYTE
	SYMBOL LEDTICK_DIV = SECTICKS * 1
	DIM tickcount AS BYTE
	DIM ledtickcount AS BYTE

'MAC header definitions
	SYMBOL MACHDR_LEN   = 14
	SYMBOL pcol_        = rxbuff#13
	SYMBOL pcol_h       = rxbuff#12
	SYMBOL pcol 		= pcol_.WORD

'ARP definitions
	SYMBOL arp_op_      = rxbuff#21
	SYMBOL arp_op_h     = rxbuff#20
	SYMBOL arp_op		= arp_op_.WORD

'IP definitions
	SYMBOL IPHDR_START  = 14
	SYMBOL IPHDR_LEN    = 20
	SYMBOL ip_pcol      = rxbuff#23

'ICMP definitions
	SYMBOL icmp_type    = rxbuff#34
	SYMBOL icmp_csum_   = rxbuff#36
	SYMBOL icmp_csum_h  = rxbuff#37
	SYMBOL icmp_csum 	= icmp_csum_.WORD
	SYMBOL rxiplen_     = rxbuff#17
	SYMBOL rxiplen_h    = rxbuff#16
    SYMBOL rxiplen 		= rxiplen_.WORD

'UDP definitions
	SYMBOL UDPHDR_START     = IPHDR_START + IPHDR_LEN
	SYMBOL UDPHDR_LEN       = 8
	SYMBOL rx_srce_port_    = rxbuff#35
	SYMBOL rx_srce_port_h   = rxbuff#34
	SYMBOL rx_srce_port 	= rx_srce_port_.WORD
	SYMBOL rx_dest_port_    = rxbuff#37
	SYMBOL rx_dest_port_h   = rxbuff#36
    SYMBOL rx_dest_port 	= rx_dest_port_.WORD

'UDP data
	SYMBOL UDP_DATA_START   = 42
	SYMBOL rx_udp_dw_       = rxbuff#45
	SYMBOL rx_udp_dw_h      = rxbuff#44
	SYMBOL rx_udp_dw_hh     = rxbuff#43
	SYMBOL rx_udp_dw_hhh    = rxbuff#42
	SYMBOL rx_udp_dw		= rx_udp_dw_.DWORD
	DIM udplen AS BYTE

'Time client variables
	DIM arped AS BIT
	
	DIM timeval AS DWORD
	DIM s AS BYTE: DIM m AS BYTE: DIM h AS BYTE

'ADC variables
	DIM adcval AS WORD
	DIM centivolts AS WORD
    DIM CLEARED_ONCE AS BIT

	Include "UDP_DATA.INC"

